function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import cs from 'classnames';
import React from 'react';
import PropTypes from 'prop-types';
import { CSSTransition } from 'react-transition-group';

const ExpandRow = ({
  children,
  expanded,
  onClosed,
  className,
  ...rest
}) => /*#__PURE__*/React.createElement("tr", null, /*#__PURE__*/React.createElement("td", _extends({
  className: cs('reset-expansion-style', className)
}, rest), /*#__PURE__*/React.createElement(CSSTransition, {
  appear: true,
  in: expanded,
  timeout: 400,
  classNames: "row-expand-slide",
  onExited: onClosed
}, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("div", {
  className: "row-expansion-style"
}, children)))));

ExpandRow.propTypes = {
  children: PropTypes.node,
  expanded: PropTypes.bool,
  onClosed: PropTypes.func,
  className: PropTypes.string
};
ExpandRow.defaultProps = {
  children: null,
  expanded: false,
  onClosed: null,
  className: ''
};
export default ExpandRow;