function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

/* eslint react/prop-types: 0 */
import React from 'react';
import cs from 'classnames';
import ExpandRow from './expand-row';
import _ from '../utils';
import ExpansionContext from '../contexts/row-expand-context';
export default (Component => {
  const renderWithExpansion = (props, expandRow) => {
    let parentClassName = '';
    let className = '';
    const key = props.value;

    const expanded = _.contains(expandRow.expanded, key);

    const isClosing = _.contains(expandRow.isClosing, key);

    const expandable = !expandRow.nonExpandable || !_.contains(expandRow.nonExpandable, key);

    if (expanded) {
      parentClassName = _.isFunction(expandRow.parentClassName) ? expandRow.parentClassName(expanded, props.row, props.rowIndex) : expandRow.parentClassName || '';
      className = _.isFunction(expandRow.className) ? expandRow.className(expanded, props.row, props.rowIndex) : expandRow.className || '';
    }

    return [/*#__PURE__*/React.createElement(Component, _extends({}, props, {
      key: key,
      expanded: expanded,
      expandable: expandable,
      expandRow: { ...expandRow
      },
      className: cs(props.className, parentClassName)
    })), expanded || isClosing ? /*#__PURE__*/React.createElement(ExpandRow, {
      key: `${key}-expanding`,
      colSpan: props.visibleColumnSize,
      expanded: expanded,
      onClosed: () => expandRow.onClosed(key),
      className: className
    }, expandRow.renderer(props.row, props.rowIndex)) : null];
  };

  return props => /*#__PURE__*/React.createElement(ExpansionContext.Consumer, null, expandRow => renderWithExpansion(props, expandRow));
});