import React from 'react';
import cs from 'classnames';
import PropTypes from 'prop-types';
import Const from '../const';
import { BootstrapContext } from '../contexts/bootstrap';

const SortCaret = ({
  order
}) => {
  const orderClass = cs('react-bootstrap-table-sort-order', {
    dropup: order === Const.SORT_ASC
  });
  return /*#__PURE__*/React.createElement(BootstrapContext.Consumer, null, ({
    bootstrap4
  }) => bootstrap4 ? /*#__PURE__*/React.createElement("span", {
    className: `caret-4-${order}`
  }) : /*#__PURE__*/React.createElement("span", {
    className: orderClass
  }, /*#__PURE__*/React.createElement("span", {
    className: "caret"
  })));
};

SortCaret.propTypes = {
  order: PropTypes.oneOf([Const.SORT_ASC, Const.SORT_DESC]).isRequired
};
export default SortCaret;